#include "vector.hpp"
#include <iostream>
using namespace std;

// Change log
//
// 04/01/07 CKR: added example of Vector::at() and exceptions
//   NOTE: to enable exceptions in Dev-C++, go to
//   Project Options | Compiler | Code Generation | Enable exception handling: Yes
// 04/01/07 CKR: increased vector size to force resizing past initial capacity

int main( )
{
  Vector<int> v;
  
  for( int i = 0; i < 50; ++i ) {
    v.push_back( i );
  }
  
  for( int i = 0; i < 5; ++i ) {
    for( int j = 0; j < 10; ++j) {
      cout << v[ i * 10 + j ] << " ";
    }
    cout << endl;
  }
  
  // v[51] just runs with undefined results  
  cout << "v[51]: " << v[51] << endl;
  
  // v.at(51) throws an exception you can catch
  try {
    cout << "v.at(51): " << v.at(51) << endl;
  }
  catch (ArrayIndexOutOfBoundsException exc) {
    cout << "vector index out of bounds" << endl;
  }
  
  return 0;
}

